using System;
using System.Collections.Generic;
using System.Text;

namespace Northwind.NET.Utilities
{
    /// <summary>
    /// Unreachable code exception
    /// </summary>
    public class UnreachableCodeException : ApplicationException
    {
        private string _message;
        /// <summary>
        /// Gets Unreachable code exception message text
        /// </summary>
        public override string Message
        {
            get { return _message; }
        }
        private Exception _exception;
        /// <summary>
        /// Gets Unreachable code exception instance
        /// </summary>
        public Exception Exception
        {
            get { return _exception; }
        }
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="message">Unreachable code exception message text</param>
        public UnreachableCodeException(string message)
        {
            _message = message;
        }
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="e">Unreachable code exception instance</param>
        /// <param name="message">Unreachable code exception message text</param>
        public UnreachableCodeException(Exception e, string message)
        {
            _message = message;
            _exception = e;
        }
    }


}
