﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Northwind.NET.Utilities
{
    /// <summary>
    /// Keeps Global constants and variables
    /// </summary>
    public sealed class Globals
    {

        private static string _logFileName = "NorthWind.NET.log";

        /// <summary>
        /// (Re)Sets Log File Name
        /// </summary>
        /// <param name="logFileName"></param>
        public static void SetLogFileName(string logFileName)
        {
            _logFileName = logFileName;
        }

        /// <summary>
        /// Gets log fullpath
        /// </summary>
        public static string LogFullPath
        {
            get
            {
                return LogFilesFolderName + _logFileName;
            }
        }

        /// <summary>
        /// Folder name of log files
        /// </summary>
        public static string LogFilesFolderName
        {
            get
            {
                return Context.ExecutingAssemblyFolderName + @"Logs\";
            }
        }
    }
}
